%define myprefix	/usr
%define httphome	/home/httpd

# we should determine these places with apxs..
# it would be nice to do this at install-time
# as well in order to dynamically 'relocate' the package.
# .. but I think we've to wait for a new RPM to make this happen
##

## unfortuatly, we don't know the location of the apxs-binary yet .. and
## it may not be in the path which will make the build fail (can
## we set defines conditionally ?)

#%define libexecdir `apxs -q LIBEXECDIR`
%define libexecdir /usr/lib/apache

#%define httpdconf `apxs -q SYSCONFDIR`
%define httpdconf  /etc/httpd/conf

%define jservconf  %{httpdconf}/jserv
%define logdir	   /var/log/httpd
%define jsdkversion 20000617
%define sourcedir  %{version}

Source:		http://www.klomp.org/gnujsp/downloads/gnujsp-1.0.0.tar.gz
Source1:	alph.properties
Summary:	GNUJSP is a free implementation of Sun's Java Server Pages.
Name:		gnujsp
Version:	1.0.0
Release:	1
URL:		http://www.klomp.org/gnujsp/
Copyright:	GPL
Group:		Networking/Daemons
Packager:	Joerg Dorchain <joerg@dorchain.net>
Requires:	jserv
Provides:	jsp
BuildRoot:	/tmp/%{name}-%{version}-root
Prefix:		%{myprefix}
BuildArch:	noarch

#BuildRequires: any-java-compiler

%description
  GNUJSP is a free implementation of Sun's Java Server Pages. Once the
  GNUJSP servlet is correctly installed, files with the extension .jsp
  are translated into java source files, compiled, and run.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -T -c

%build

%install

mkdir -p $RPM_BUILD_ROOT/var/cache/jsp
mkdir -p $RPM_BUILD_ROOT/%{jservconf}
cp %{SOURCE1} $RPM_BUILD_ROOT/%{jservconf}
mkdir -p $RPM_BUILD_ROOT/%{httphome}
cd $RPM_BUILD_ROOT/%{httphome}
tar -xvzf %{SOURCE0}
mv %{name}-%{version} %{name}
cd %{name}
%_fixowner .
%_fixgroup .
%_fixperms .
cp AUTHORS CHANGES COPYING COPYING.LIB FAQ INSTALL* README TODO install.html $RPM_BUILD_DIR/%{name}-%{version}


%post
#
# determine apache-USER and chown the scratch directoriy - file
#
APACHEUSER=`grep "^User[	 ]\+" %{httpdconf}/httpd.conf | awk '{print $2}'`
if test ! "x$APACHEUSER" = x ; then
   USERCOMMENT="(which is '$APACHEUSER' ?)"
else
   # assumption:
   APACHEUSER=nobody
fi
chown $APACHEUSER /var/cache/jsp

#
# determine DocumentRoot and put it into conf-file
#
PAGEBASE=`grep "^DocumentRoot[	 ]\+" %{httpdconf}/httpd.conf | awk '{print $2}'`
if test ! "x$PAGEBASE" = x ; then
   USERCOMMENT="(which is '$PAGEBASE' ?)"
else
   # assumption:
   PAGEBASE=%{httphome}/html
fi
mv %{jservconf}/alph.properties %{jservconf}/alph.properties.rpminstall
sed s%@@PAGEBASE@@%$PAGEBASE% <%{jservconf}/alph.properties.rpminstall >%{jservconf}/alph.properties
rm %{jservconf}/alph.properties.rpminstall

cp %{jservconf}/jserv.conf %{jservconf}/jserv.conf.rpmorig
#
# ApjServMount
#
grep "#?.*ApJservMount.*/alph.*/alph" %{jservconf}/jserv.conf \
     >/dev/null
if test $? -eq 0 ; then
   # found. Remove any comment
   sed 's|^#.*\(ApJServMount.*/alph\)|\1|g' \
       < %{jservconf}/jserv.conf                 \
       > %{jservconf}/jserv.conf.loadMod
   mv %{jservconf}/jserv.conf.loadMod %{jservconf}/jserv.conf
else
   # Insert ApJservMount line before first valid ApServMount
   ( echo "/^ApJServMount"
     echo "i"
     echo "ApJServMount	/alph	/alph"
     echo "."
     echo "wq"
   ) | ed %{jservconf}/jserv.conf > /dev/null 2>&1
fi

#
# ApjServAction
#
grep "#?.*ApJservAction.*\.jsp.*/alph/gnujsp" %{jservconf}/jserv.conf \
     >/dev/null
if test $? -eq 0 ; then
   # found. Remove any comment
   sed 's|^#.*\(ApJServAction.*/\.jsp\)|\1|g' \
       < %{jservconf}/jserv.conf                 \
       > %{jservconf}/jserv.conf.loadMod
   mv %{jservconf}/jserv.conf.loadMod %{jservconf}/jserv.conf
else
   # Insert ApJservMount line before first valid ApServMount
   ( echo "/^#ApJServAction"
     echo "a"
     echo "ApJServAction	.jsp	/alph/gnujsp"
     echo "."
     echo "wq"
   ) | ed %{jservconf}/jserv.conf > /dev/null 2>&1
fi

cp %{jservconf}/jserv.properties %{jservconf}/jserv.properties.rpmorig
#
# properties
#
grep "#?.*alph.properties" %{jservconf}/jserv.properties \
     >/dev/null
if test $? -eq 0 ; then
   # found. Remove any comment
   sed 's|^#.*\(alph.properties\)|\1|g' \
       < %{jservconf}/jserv.properties                 \
       > %{jservconf}/jserv.properties.loadMod
   mv %{jservconf}/jserv.properties.loadMod %{jservconf}/jserv.properties
else
   # Insert ApJservMount line before first valid ApServMount
   ( echo "/^root.properties"
     echo "a"
     echo "alph.properties=%{jservconf}/alph.properties"
     echo "."
     echo "wq"
   ) | ed %{jservconf}/jserv.properties > /dev/null 2>&1
fi

#
# zone
#
grep '^zones' %{jservconf}/jserv.properties |grep alph\
     >/dev/null
if ! test $? -eq 0 ; then
   # Insert ApJservMount line before first valid ApServMount
   ( echo "/^zones"
     echo "a"
     echo ",alph"
     echo "."
     echo "-1"
     echo "j"
     echo "wq"
   ) | ed %{jservconf}/jserv.properties > /dev/null 2>&1
fi

%preun
# do not remove the configured stuff if we upgrade.
# the $1 argument contains the number of packages _after_ installation.
if [ ! $1 -eq 0 ] ; then
   exit 0
fi

#
# Find jserv related configuration settings and comment
# them out
#
cp %{jservconf}/jserv.conf %{jservconf}/jserv.conf.rpmorig
sed 's|^\(ApJServMount.*/alph\)|#\1|g' \
    < %{jservconf}/jserv.conf.rpmorig                \
    | sed 's|^\(ApJServAction.*\.jsp\)|#\1|g'      \
    > %{jservconf}/jserv.conf

cp %{jservconf}/jserv.properties %{jservconf}/jserv.properties.rpmorig
sed 's|.*\(alph.properties.*\)|#\1|g' \
    < %{jservconf}/jserv.properties.rpmorig                \
    | sed 's|\(,alph\)||g'      \
    > %{jservconf}/jserv.properties

%files
%defattr(-,root,root)
%doc AUTHORS CHANGES COPYING COPYING.LIB FAQ INSTALL* README TODO install.html

%{httphome}
%dir /var/cache/jsp

%config %{jservconf}/alph.properties

%changelog
